'FFSubmenu=IPTC
'FFName=Schlagworteintrag

'(c) Harald Maeckler, Dsseldorf 2016 - 2021
' ***********************************************************************
' Schlagworteintrag.vbs (Skript fr FixFoto)
' Schlagwort eintragen in die IPTC-Daten.
' ***********************************************************************
'
' Version 1.03 vom 29.01.2021	- Updatefunktion angepasst
' Version 1.02 vom 28.11.2017	- berarbeitung der Kurzbeschreibung
' Version 1.01 vom 26.06.2016	- filtern nach JPEG-Bildern
' Version 1.00 vom 22.05.2016	- Betaversion
' ***********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.03"
const SkriptURL = "https://www.ffsf.de/resources/schlagworteintrag.352/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort

'Spezifische Konstanten und Variable
Dim IPTC_Neu,Bilder_Array,n,Vorhanden,IPTC_Date

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "Schlagworteintrag"					'Skriptname
const RegSchluessel = "FF_Schlagworteintrag"		'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Schlagworteintrag **
FF_AddDialog "Schlagworteintrag",119,76
FF_AddControl "Schlagworteintrag","Schlagwort","STATIC",9,3,32,10
FF_AddControl "Schlagworteintrag","Schlagwort_wert","SLEDIT",9,13,100,10
FF_AddControl "Schlagworteintrag","in selektierten JPG-Bildern","STATIC",52,49,64,10
FF_SetControlStyle "Schlagworteintrag","in selektierten JPG-Bildern",1
FF_AddControl "Schlagworteintrag","&Lschen","BUTTON",55,60,28,11
FF_AddControl "Schlagworteintrag","&Eintragen","BUTTON",84,60,28,11
FF_AddControl "Schlagworteintrag","?","BUTTON",6,60,11,11
FF_AddControl "Schlagworteintrag","|","STATIC",27,49,20,10
FF_SetControlStyle "Schlagworteintrag","|",1
FF_AddControl "Schlagworteintrag","Update","BUTTON",23,60,28,11
FF_AddControl "Schlagworteintrag","&delete","BUTTON",0,0,1,1
FF_AddControl "Schlagworteintrag","Fortschritt","PROGRESS",3,28,112,4
FF_AddControl "Schlagworteintrag","mit Backspace-Taste den Durchlauf abbrechen","STATIC",2,34,114,11
FF_SetControlStyle "Schlagworteintrag","mit Backspace-Taste den Durchlauf abbrechen",1
'** End Dialog Schlagworteintrag **


'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Schlagworteintrag","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Schlagworteintrag","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Schlagworteintrag","&Lschen", "" &_
						 "Schlagwort in allen ausgewhlten" & vbNewLine &_
						 "Bildern lschen" & vbNewLine &_
						 "(auch mit Alt + L aufrufbar)"
	FF_SetControlTooltip "Schlagworteintrag","&Eintragen", "" &_
						 "Schlagwort in allen ausgewhlten" & vbNewLine &_
						 "Bildern eintragen" & vbNewLine &_
						 "(auch mit Alt + E aufrufbar)"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500

FF_SetDialogTimer "Schlagworteintrag", 100
FF_ActivateControl "Schlagworteintrag","&delete"
FF_ActivateControl "Schlagworteintrag","Schlagwort_wert"


do
	Abbruch = false
	Select Case FF_ShowDialog ("Schlagworteintrag")
	Case "TIMER"
		FF_SetControl "Schlagworteintrag" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Schlagworteintrag", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "?"
		'FF_SetControl "Schlagworteintrag","Fortschritt",65	'############## nur fr Screenshot
		WshShell.Popup "" & _
			"Mit dem Skript knnen Schlagworte in die IPCT-Daten eines" & vbNewLine &_
			"JPG-Bildes eingetragen oder auch gelscht werden. Dazu" & vbNewLine &_
			"muss ein Bild oder mehrere Bilder im Computerverzeichnis" & vbNewLine &_
			"markiert werden." & vbNewLine &vbNewLine &_
			"Nach Eingabe eines Schlagworts wird mit" & vbNewLine &_
			"	- Klick auf 'Eintragen' bzw." & vbNewLine &_
			"	   durch Bettigung der Tastenkombination Alt + E" & vbNewLine &_
			"	   das Schlagwort in die ausgewhlten Bilder" & vbNewLine &_
			"	   eingetragen." & vbNewLine &_
			"	   Ein Doppeleintrag wird dabei unabhngig von" & vbNewLine &_
			"	   Gro- und Kleinschreibung vermieden." & vbNewLine &_
			"	- Klick auf 'Lschen' bzw." & vbNewLine &_
			"	   durch Bettigung der Tastenkombination Alt + L" & vbNewLine &_
			"	   das Schlagwort in den ausgewhlten Bilder" & vbNewLine &_
			"	   gelscht." & vbNewLine &vbNewLine &_
			"Mit dem Befehl 'Update' kann geprft werden, ob eine neue" & vbNewLine &_
			"Skriptversion vorliegt. Voraussetzung ist eine bestehende" & vbNewLine &_
			"Internetverbindung. Ggf. kann die Downloadseite direkt" & vbNewLine &_ 
			"aufgerufen werden." & vbNewLine & vbNewLine &_
			"Mit Bettigung der Tastenkombination Alt + D kann fr das" & vbNewLine &_
			"Skript eine Lschroutine aufgerufen werden." & vbNewLine & vbNewLine &_
			"Copyright Harald Maeckler" &_
			"",,"Erluterungen",vbInformation
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "&Lschen"
		call Kontrolle
		if not Abbruch then
			call Loeschen
			if not Abbruch then exit do
		end if
	Case "&Eintragen"
		call Kontrolle
		if not Abbruch then
			call Eintrag
			if not Abbruch then exit do
		end if
	Case "CANCEL"
		exit do
	End Select
loop

FF_CloseDialog ("Schlagworteintrag")
if SkriptKill then			'ggf. Skript komplett entfernen
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub Kontrolle
	
if len(FF_GetSelection(1)) = 0 then
	msgbox "Es ist kein Bild selektiert!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

IPTC_Neu = trim(FF_GetControl("Schlagworteintrag","Schlagwort_wert"))
if len(IPTC_Neu) = 0 then
	msgbox "Es muss ein Schlagwort eingegeben werden!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

Bilder_Array = split(FF_GetSelection(1),vbNewLine)

End Sub
'------------------------------------------------------------------------
Sub Loeschen
Dim Vorhanden_Array,element

for n = 0 to ubound(Bilder_Array)
	if FF_IdentifyImage(Bilder_Array(n)) = 2  then
		FF_LoadImage Bilder_Array(n)
		if FF_HasIPTC then
			Vorhanden = FF_GetIPTC("Keywords")
			Vorhanden_Array = split(Vorhanden,vbNewLine)
			for each element in Vorhanden_Array
				if ucase(element) <> ucase(IPTC_Neu) then
					if len(IPTC_Date) = 0 then
						IPTC_Date = element
					else
						IPTC_Date = IPTC_Date & vbNewLine & element
					end if
				end if
			next
			FF_SetIPTC "Keywords", IPTC_Date
			FF_SaveIPTC Bilder_Array(n)
		end if
	end if
	
	'### Fortschrittsanzeige
	FF_SetControl "Schlagworteintrag","Fortschritt",(n +1)/(ubound(Bilder_Array) +1)*100

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & Anz & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						"Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit sub
	end if
	
next

End Sub
'------------------------------------------------------------------------
Sub Eintrag

for n = 0 to ubound(Bilder_Array)
	if FF_IdentifyImage(Bilder_Array(n)) = 2  then
		FF_LoadImage Bilder_Array(n)
		if FF_HasIPTC then
			Vorhanden = FF_GetIPTC("Keywords")
			if len(Vorhanden) = 0 then
				IPTC_Date = IPTC_Neu
			else
				if instr(ucase(vbNewLine & Vorhanden & vbNewLine),ucase(vbNewLine & IPTC_Neu & vbNewLine)) = 0 then
					IPTC_Date = Vorhanden & vbNewLine & IPTC_Neu
				else
					IPTC_Date = Vorhanden
				end if
			end if
			FF_SetIPTC "Keywords", IPTC_Date
			FF_SaveIPTC Bilder_Array(n)
		end if
	end if
	
	'### Fortschrittsanzeige
	FF_SetControl "Schlagworteintrag","Fortschritt",(n +1)/(ubound(Bilder_Array) +1)*100

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & Anz & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						"Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit sub
	end if
	
next

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\Schlagworteintrag"
'if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
'TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
'WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
